// textareaにコピーする
function copyStr2Textarea(str){
	document.getElementById("ChromePlugin-selector").value = str;
}
// 保存条件のリロード
function redrawStoredSelector(){

	var el_disp = document.getElementById("ChromePlugin-storedSelectorsDisp");
	el_disp.innerHTML = "";

	chrome.storage.local.get("MYSCRAPER_DATA", function (myscraper_data) {

		var value = myscraper_data["MYSCRAPER_DATA"];

		for(p in value){
			var el_sp = document.createElement("span");
			el_sp.setAttribute("selector-value", p);
			el_sp.innerHTML = value[p] + "(" + p + ")" + "\n";

			var el_btn = document.createElement("button");
			el_btn.setAttribute("selector-value-del", p);
			el_btn.innerHTML = "×";

			var el_wrapper = document.createElement("li");
			el_wrapper.appendChild(el_sp);
			el_wrapper.appendChild(el_btn);

			el_disp.appendChild(el_wrapper);
		}
	});
}

document.addEventListener("DOMContentLoaded", function() {

	// デフォルトで保存条件は表示しておこう
	redrawStoredSelector();

	// GETボタン押下
	document.getElementById("ChromePlugin-doScrape").addEventListener("click", function(){

		var selector = document.getElementById("ChromePlugin-selector").value;
		if(!selector || (selector == "")){
			alert("no selector...");
			return;
		}

		chrome.tabs.query({active: true, currentWindow: true}, function(tabs) {
	     	chrome.tabs.sendMessage(tabs[0].id, {
	      		selector: selector
	      	},
	      	function(msg) {
	        	document.getElementById("ChromePlugin-result-disp").innerHTML = msg;
	      	});
    	});
	});

	// save selector
	document.getElementById("ChromePlugin-saveSelector").addEventListener("click", function(){
		var selector = document.getElementById("ChromePlugin-selector").value;

		if(selector && (selector != "")){
			var prop_logical_name = window.prompt("保存するセレクタの名前(必須)", "");

			if(prop_logical_name){
				chrome.storage.local.get("MYSCRAPER_DATA", function (myscraper_data) {

					var save_value = myscraper_data["MYSCRAPER_DATA"];
					save_value[selector] = prop_logical_name;
					chrome.storage.local.set({MYSCRAPER_DATA: save_value}, function() {
					    //alert("保存しました");
					    redrawStoredSelector();
					});
				});
			}
		}
	});

	// get selector
	/*
	document.getElementById("ChromePlugin-getSelector").addEventListener("click", function(){
		chrome.storage.local.get("MYSCRAPER_DATA", function (myscraper_data) {
			redrawStoredSelector();
		});
	});
	*/

	document.getElementById("ChromePlugin-storedSelectorsDisp").addEventListener("click", function(event){
		if(event.target.tagName.toLowerCase() == "span"){
			copyStr2Textarea(event.target.getAttribute("selector-value"));
		}
		else if(event.target.tagName.toLowerCase() == "button"){

			var selector_value = event.target.getAttribute("selector-value-del");

			if(selector_value){
				// delete
				chrome.storage.local.get("MYSCRAPER_DATA", function (myscraper_data) {

					var save_value = myscraper_data["MYSCRAPER_DATA"];

					delete save_value[selector_value];

					chrome.storage.local.set({MYSCRAPER_DATA: save_value}, function() {
					    //alert("削除しました");
					    redrawStoredSelector();
					});
				});
			}
		}
	});
});